use gtk4 as gtk;

use crate::model::model::SchemeCharacteristics;
use gtk::{prelude::*, *};

pub fn check_characteristics(
    raw_characteristics: &Vec<TextView>,
    all_inputs_data: &mut Vec<f64>,
    output: &mut String,
) -> bool {
    for input in raw_characteristics {
        let (iter_start, iter_end) = input.buffer().bounds();
        let parsed_input: Result<f64, _> = input
            .buffer()
            .text(&iter_start, &iter_end, false)
            .to_string()
            .trim()
            .parse();

        match parsed_input {
            Ok(int) => {
                all_inputs_data.push(int);
                println!("{:?}", int);
            }
            Err(err) => {
                if output.len() == 0 {
                    output.push_str("Введите пожалуйста числа в полях");
                    println!("{:?}", err);
                }
            }
        }
    }

    if output.len() != 0 {
        false
    } else {
        true
    }
}

pub fn start_algorithm(error_log_label: &Label, raw_characteristics: &Vec<TextView>) {
    let mut all_inputs_data: Vec<f64> = Vec::new();
    let mut output: String = String::new();

    if let false = check_characteristics(raw_characteristics, &mut all_inputs_data, &mut output) {
        error_log_label.set_text(output.as_str());
    } else {
        error_log_label.set_text("");

        let (L, Rm, Cm, Vs, Rs, f): SchemeCharacteristics = (
            all_inputs_data[0],
            all_inputs_data[1],
            all_inputs_data[2],
            all_inputs_data[3],
            all_inputs_data[4],
            all_inputs_data[5],
        );

        let mut frequencies: Vec<usize> = vec![f as usize, 1usize];

        frequencies.append(&mut (0..100).step_by(5).collect());
    }
}
