use crate::model::builder_traits::*;
use gtk4 as gtk;

use gtk::{prelude::*, StackTransitionType::SlideLeftRight, *};

use crate::view::components::pages::Pages;

#[allow(unused)]
use crate::view::{
    components::{wrapper::*, *},
    pages::*,
    properties::*,
};

pub fn ui(application: &adw::Application) {
    let hamming_code = Wrapper::row_builder()
        .set_align(Alignment::new(Align::Fill, Align::Fill))
        .set_margin(MarginData::EqualsMargin(15))
        .spacing(10)
        .build();

    hamming_code::hamming_code_page(&hamming_code);

    let signal_reducing = Wrapper::row_builder()
        .set_align(Alignment::new(Align::Fill, Align::Fill))
        .set_margin(MarginData::EqualsMargin(15))
        .spacing(10)
        .build();

    signal_reducing::signal_reducing_page(&signal_reducing);

    let pages = Pages::builder()
        .set_transition(SlideLeftRight, 200)
        .append_items(vec![
            ("Код Хэмминга", "Код Хэмминга", &hamming_code),
            ("Затухание сигнала", "Затухание сигнала", &signal_reducing),
        ])
        .build(5)
        .get();

    let window = ApplicationWindow::builder()
        .title("Комплексная программа для лаб. работ")
        .width_request(700)
        .height_request(400)
        .application(application)
        .child(&pages)
        .build();

    window.show();
}
